<script setup lang="ts">
import { computed, onMounted, reactive } from "vue";
import { useResourceStore } from "@/stores/resources";
import ResourceCard from "@/components/resources/ResourceCard.vue";
import CardTransitionGroup from "@/components/transitions/CardTransitionGroup.vue";
import { useUserStore } from "@/stores/users";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import type { ResourceOut, ResourceVersionOut } from "@/client/types.gen";
import ReasonModal from "@/components/modals/ReasonModal.vue";
import { Modal, Toast } from "bootstrap";
import BootstrapToast from "@/components/BootstrapToast.vue";

const resourceRepository = useResourceStore();
const userRepository = useUserStore();
let requestReasonModal: Modal | null = null;
let syncRequestSuccessToast: Toast | null = null;

const resourceState = reactive<{
  loading: boolean;
  filterString: string;
  sortDesc: boolean;
  showPrivate: boolean;
  syncResourceVersion?: ResourceVersionOut;
}>({
  loading: true,
  filterString: "",
  sortDesc: true,
  showPrivate: false,
  syncResourceVersion: undefined,
});

const sortedResourcesByName = computed<ResourceOut[]>(() => {
  return [...resourceRepository.resources].sort((a, b) =>
    a.name < b.name ? 1 : -1,
  );
});

const sortedResources = computed<ResourceOut[]>(() => {
  if (resourceState.sortDesc) {
    return [...sortedResourcesByName.value].reverse();
  }
  return sortedResourcesByName.value;
});

const filteredSortedResources = computed<ResourceOut[]>(() => {
  return sortedResources.value
    .filter((resource) => !resource.private || resourceState.showPrivate)
    .filter((resource) => {
      return resourceState.filterString.length > 0
        ? resource.name.includes(resourceState.filterString)
        : true;
    });
});

function requestResourceSync(
  reason: string,
  resourceVersion?: ResourceVersionOut,
) {
  if (resourceVersion != undefined) {
    resourceRepository
      .requestSynchronization(resourceVersion, {
        reason: reason,
      })
      .then(() => {
        requestReasonModal?.hide();
        syncRequestSuccessToast?.show();
      });
  }
}

onMounted(() => {
  requestReasonModal = new Modal("#request-synchronization-modal");
  syncRequestSuccessToast = new Toast("#request-sync-toast");
  resourceRepository
    .fetchPublicResources(() => {
      resourceState.loading = false;
    })
    .then((resources) => {
      userRepository.fetchUsernames(resources.map((r) => r.maintainer_id));
    });
});
</script>

<template>
  <bootstrap-toast toast-id="request-sync-toast" color-class="success">
    Requested resource synchronization
  </bootstrap-toast>
  <reason-modal
    modal-id="request-synchronization-modal"
    modal-label=""
    :loading="false"
    purpose="request"
    @save="
      (reason) => requestResourceSync(reason, resourceState.syncResourceVersion)
    "
  >
    <template #header> Request resource synchronization</template>
  </reason-modal>
  <div class="row border-bottom mb-4">
    <h2 class="mb-2">Available Resources</h2>
  </div>
  <div class="d-flex m-2 mb-3 align-items-center justify-content-start">
    <div class="col-5">
      <div class="input-group rounded shadow-sm">
        <span id="resources-search-wrapping" class="input-group-text"
          ><font-awesome-icon icon="fa-solid fa-magnifying-glass"
        /></span>
        <input
          id="filterResourcesInput"
          v-model.trim="resourceState.filterString"
          type="search"
          class="form-control"
          placeholder="Filter Resources"
          aria-label="Filter Resources"
          aria-describedby="resources-search-wrapping"
          :disabled="resourceState.loading"
          maxlength="20"
        />
      </div>
    </div>
    <div class="form-check form-check-reverse form-check-inline fs-6 ms-auto">
      <input
        id="public-resources-checkbox"
        v-model="resourceState.showPrivate"
        class="form-check-input"
        type="checkbox"
      />
      <label class="form-check-label" for="public-resources-checkbox">
        Show private resources
      </label>
    </div>
    <font-awesome-icon
      :icon="
        resourceState.sortDesc
          ? 'fa-solid fa-arrow-down-wide-short'
          : 'fa-solid fa-arrow-up-wide-short'
      "
      class="fs-5 cursor-pointer ms-2"
      @click="resourceState.sortDesc = !resourceState.sortDesc"
    />
  </div>
  <div v-if="!resourceState.loading">
    <div
      v-if="resourceRepository.resources.length === 0"
      class="text-center fs-2 mt-5"
    >
      <font-awesome-icon
        icon="fa-solid fa-x"
        class="my-5 fs-0"
        style="color: var(--bs-secondary)"
      />
      <p>
        There are no resources
        <span v-if="resourceState.showPrivate">public</span> in the system.
        Please come again later.
      </p>
    </div>
    <div
      v-else-if="filteredSortedResources.length === 0"
      class="text-center fs-2 mt-5"
    >
      <font-awesome-icon
        icon="fa-solid fa-magnifying-glass"
        class="my-5 fs-0"
        style="color: var(--bs-secondary)"
      />
      <p>
        Could not find any Resources containing<br />'{{
          resourceState.filterString
        }}'
      </p>
    </div>
    <CardTransitionGroup
      v-else
      class="d-flex flex-wrap align-items-center justify-content-between"
    >
      <resource-card
        v-for="resource in filteredSortedResources"
        :key="resource.resource_id"
        :resource="resource"
        :loading="false"
        style="min-width: 47%; max-width: 48%"
        @click-request-sync="
          (version) => (resourceState.syncResourceVersion = version)
        "
      />
    </CardTransitionGroup>
  </div>
  <div
    v-else
    class="d-flex flex-wrap align-items-center justify-content-between"
  >
    <resource-card
      v-for="resource in 4"
      :key="resource"
      :resource="{
        name: '',
        description: '',
        source: '',
        resource_id: '',
        versions: [],
        maintainer_id: '',
      }"
      style="min-width: 48%"
      loading
    />
  </div>
</template>

<style scoped></style>
